function XYZ=RGB2XYZ(RGB)
% by F.C.
N=size(RGB,1);
var_R = ( RGB(:,1)  );        %R from 0 to 1
var_G = ( RGB(:,2)  );        %G from 0 to 1
var_B = ( RGB(:,3)  );        %B from 0 to 1

for i=1:3
  I=find(RGB(:,i) > 0.0404482362771076);
  RGB(I,i) = ( ( RGB(I,i) + 0.055 ) / 1.055 ).^ 2.4;
  I=setdiff(1:N,I);
  RGB(I,i) = RGB(I,i) / 12.92;
end

% Observer. = 2°, Illuminant = D65
%  X = var_R * 0.4124 + var_G * 0.3576 + var_B * 0.1805;
%  Y = var_R * 0.2126 + var_G * 0.7152 + var_B * 0.0722;
%  Z = var_R * 0.0193 + var_G * 0.1192 + var_B * 0.9505;
A=[0.4123955889674142161,0.3575834307637148171,0.1804926473817015735; ...
   0.2125862307855955516,0.7151703037034108499,0.07220049864333622685; ...
   0.01929721549174694484,0.1191838645808485318,0.9504971251315797660]';
XYZ=RGB*A;